package com.ieso.secureClient;

import static org.junit.Assert.assertEquals;

import java.io.File;
import java.net.Authenticator;
import java.net.MalformedURLException;
import java.net.PasswordAuthentication;
import java.net.URL;
import java.util.Map;

import javax.xml.ws.BindingProvider;

import org.jboss.ws.core.StubExt;
import org.junit.Test;

import com.ieso.securityws.SecureWs;
import com.ieso.securityws.SecureWsService;

public class TestSecureClient {
	private String word = "Hello";
	private String echo = word +" "+word;
	
	private static SecureWs getPort(final String user, final String pass) throws MalformedURLException{
		SecureWs port = new SecureWsService().getSecureWsPort();

		URL securityURL = new File("WEB-INF/jboss-wsse-client.xml").toURL(); 
		((StubExt)port).setSecurityConfig(securityURL.toExternalForm()); 
		((StubExt)port).setConfigName("Standard WSSecurity Client"
				, "WEB-INF/standard-jaxws-client-config.xml"); 
		
		Map<String, Object> reqContext = ((BindingProvider) port).getRequestContext();
		reqContext.put(BindingProvider.USERNAME_PROPERTY, user);
		reqContext.put(BindingProvider.PASSWORD_PROPERTY, pass);
		
		return port;
	}
//
//	@Test
//	public void testRightCredentialsWithNoAuth() throws MalformedURLException{
//		SecureWs port = getPort("kermit","thefrog",false,false);
//		assertEquals(port.echo(word), echo);
//	}	
//	
//	@Test
//	public void testRightCredentialsWithDoubleAuth() throws MalformedURLException{
//		SecureWs port = getPort("kermit","thefrog",true,true);
//		assertEquals(port.echo(word), echo);
//	}
//	
//	@Test
//	public void testWrongCredentialsWithDoubleAuth() throws MalformedURLException{
//		assertEquals(getPort("ralph","thedog",true,true).echo(word), echo);
//	}
	
	@Test
	public void testRightCredentials() throws MalformedURLException{
		SecureWs port = getPort("kermit", "thefrog");
		
		assertEquals(port.echo(word), echo);
	}
	
	@Test(expected=javax.xml.ws.soap.SOAPFaultException.class)
	public void testWrongCredentials() throws MalformedURLException{
		SecureWs port = getPort("ralph", "thedog");
				
		assertEquals(port.echo(word), echo);
	}
}
